<template>
    <div>
      <div class="gva-search-box">
        <el-form ref="searchForm" :inline="true" :model="searchInfo">
          <el-form-item label="电脑编号">
            <el-input v-model="searchInfo.pc_code" placeholder="电脑编号" />
          </el-form-item>
          <el-form-item label="开发者">
            <el-input v-model="searchInfo.operator" placeholder="开发者" />
          </el-form-item>
          <el-form-item label="游戏id">
            <el-input v-model="searchInfo.game_id" placeholder="游戏id" />
          </el-form-item>
          <el-form-item label="日期" prop="create_date">
           <el-date-picker
            v-model="searchInfo.create_date"
            popper-class="picker-popovers"
            class="timefilter"
            type="datetime"
            placeholder="选择日期时间"
            value-format="YYYY-MM-DD"
          >
          </el-date-picker>
          </el-form-item>
          <el-form-item>
            <el-button size="small" type="primary" icon="search" @click="onSubmit">查询</el-button>
            <el-button size="small" icon="refresh" @click="onReset">重置</el-button>
          </el-form-item>
        </el-form>
      </div>
      <div class="gva-table-box">
        <el-table :data="tableData"  @sort-change="sortChange" @selection-change="handleSelectionChange"
        border
        >
          <el-table-column
            type="selection"
            width="55"
          />
          <el-table-column align="left" label="游戏id" min-width="150" prop="game_id" sortable="custom" />
          <el-table-column align="left" label="电脑数" min-width="100" prop="pc_code_total" />
          <el-table-column align="left" label="日期" min-width="150" prop="create_date" />
          <el-table-column align="left" label="总任务" min-width="150" prop="target_num" />
          <el-table-column align="left" label="进入主线总数" min-width="150" prop="enter_main_total" />
          <el-table-column align="left" label="主线成功总数" min-width="150" prop="task_success_total" />
          <el-table-column align="left" label="单台电脑完成任务" min-width="150" prop="one_computer_average_num" />
          <el-table-column align="left" label="最后半小时内付费" min-width="150" prop="game_fee_rate" />
          <el-table-column align="left" label="任务完成效率(/h)" min-width="150" prop="computer_hour_average_total" />
          <el-table-column align="left" label="电脑总空闲时间" min-width="150" prop="computer_free_time_total" />
        </el-table>
        <div class="gva-pagination">
          <el-pagination
            :current-page="page"
            :page-size="pageSize"
            :page-sizes="[10, 30, 50, 100]"
            :total="total"
            layout="total, sizes, prev, pager, next, jumper"
            @current-change="handleCurrentChange"
            @size-change="handleSizeChange"
          />
        </div>
  
      </div>
  
      <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" :title="dialogTitle">
        <el-form ref="apiForm" :model="form" :rules="rules" label-width="80px">
          <el-form-item label="游戏名称" prop="game_name">
            <el-input v-model="form.game_name" autocomplete="off" />
          </el-form-item>
          <el-form-item label="游戏包名" prop="game_package_name">
            <el-input v-model="form.game_package_name" autocomplete="off" />
          </el-form-item>
        </el-form>
        <template #footer>
          <div class="dialog-footer">
            <el-button size="small" @click="closeDialog">取 消</el-button>
            <el-button size="small" type="primary" @click="enterDialog">确 定</el-button>
          </div>
        </template>
      </el-dialog>
    </div>
  </template>
  
  <script>
  export default {
    name: 'GameIdList',
  }
  </script>
  
  <script setup>
  import {
    logGameIdList,
  } from '@/api/log'
  import { toSQLLine } from '@/utils/stringFun'
  import { ref } from 'vue'
  import { ElMessage, ElMessageBox } from 'element-plus'
  import warningBar from '@/components/warningBar/warningBar.vue'
  
  const apis = ref([])
  const form = ref({
      game_name: '',
      game_package_name: ''
  })
  
  
  const type = ref('')
  const rules = ref({
    game_name: [{ required: true, message: '请输入游戏名称', trigger: 'blur' }],
    game_package_name: [
      { required: true, message: '请输入游戏包名', trigger: 'blur' }
    ]
  })
  
  const typeFiletr = (value) => {
    const target = typeOptions.value.filter(item => item.value === value)[0]
    return target && `${target.label}`
  }
    
    const typeOptions = ref([
    {
      value: 0,
      label: '脚本',
      type: ''
    },
    {
      value: 1,
      label: '中控',
      type: ''
    }
  ])
  
  const page = ref(1)
  const total = ref(0)
  const pageSize = ref(10)
  const tableData = ref([])
  let spanArr = []
  const searchInfo = ref({})
  
  const onReset = () => {
    searchInfo.value = {}
  }
  
  const spanArrReset = () => {
    for (var i = 0; i < spanArr.length; i++) {
        spanArr.pop()
    } 
  }
  

  const value = ref('')
  const statusList = [
    {
      value: 1,
      label: '成功',
    },
    {
      value: 2,
      label: '失败',
    },
  ]
  
  const options = [
    {
      value: 45010,
      label: '启动游戏',
    },
    {
      value: 46010,
      label: '小绵羊登录',
    },
    {
      value: 46020,
      label: '微信登录',
    },
    {
      value: 46030,
      label: '魅族登录',
    },
    {
      value: 46050,
      label: '进入游戏',
    },
    {
      value: 47010,
      label: '主线教程',
    },
    {
      value: 46040,
      label: '选区',
    },
    {
      value: 46070,
      label: '实名认证',
    },
  ]
  // 搜索
  
  const onSubmit = () => {
    page.value = 1
    pageSize.value = 10
    searchInfo.value.game_id = Number(searchInfo.value.game_id)
    searchInfo.value.coding = Number(searchInfo.value.coding)
    getTableData()
  }

  const getSpanArr = (data) => {
    spanArr = []
    var pos = 0
    for (var i = 0; i < data.length; i++) {
          if (i === 0) {
            spanArr.push(1);
            pos = 0
          } else {
            if (data[i].pc_code === data[i - 1].pc_code) {
              spanArr[pos] += 1;
              spanArr.push(0);
            } else {
              spanArr.push(1);
              pos = i;
            }
          }
        }
        console.log(spanArr)  
  }

  const objectSpanMethod = (row) => {
    if (row.columnIndex === 1 || row.columnIndex === 2 || row.columnIndex === 3 || row.columnIndex === 0) {
          const rowspan = spanArr[row.rowIndex];
          const colspan = rowspan > 0 ? 1 : 0;
          return {
            rowspan: rowspan,
            colspan: colspan
          }
        }
  }
 

  
  // 分页
  const handleSizeChange = (val) => {
    pageSize.value = val
    getTableData()
  }
  
  const handleCurrentChange = (val) => {
    page.value = val
    getTableData()
  }
  
  // 排序
  const sortChange = ({ prop, order }) => {
    if (prop) {
      if (prop === 'id') {
        prop = 'id'
      }
      searchInfo.value.orderKey = toSQLLine(prop)
      searchInfo.value.desc = order === 'descending'
    }
    getTableData()
  }
  
  // 查询
  const getTableData = async() => {
    const table = await logGameIdList({ page: page.value, pageSize: pageSize.value, ...searchInfo.value })
    if (table.code === 0) {
      tableData.value = table.data.list
      total.value = table.data.total
      page.value = table.data.page
      pageSize.value = table.data.pageSize
      getSpanArr(table.data.list)
    }
  }
  
  getTableData()
  
  // 批量操作
  const handleSelectionChange = (val) => {
    apis.value = val
  }
  
  const deleteVisible = ref(false)
  
  
  // 弹窗相关
  const apiForm = ref(null)
  const initForm = () => {
    apiForm.value.resetFields()
    form.value = {
      game_name: '',
      game_package_name: ''
    }
  }
  
  const dialogTitle = ref('新增game')
  const dialogFormVisible = ref(false)
  const openDialog = (key) => {
    switch (key) {
      case 'addGame':
        dialogTitle.value = '新增game'
        break
      case 'edit':
        dialogTitle.value = '编辑game'
        break
      default:
        break
    }
    type.value = key
    dialogFormVisible.value = true
  }
  const closeDialog = () => {
    initForm()
    dialogFormVisible.value = false
  }
  
  const editCardFunc = async(row) => {
    const res = await getGameById({ id: row.id })
    form.value = res.data
    openDialog('edit')
  }
  
  const enterDialog = async() => {
    apiForm.value.validate(async valid => {
      if (valid) {
        switch (type.value) {
          case 'addGame':
            {
              const res = await cuGame(form.value)
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '添加成功',
                  showClose: true
                })
              }
              getTableData()
              closeDialog()
            }
  
            break
          case 'edit':
            {
              const res = await cuGame(form.value)
              if (res.code === 0) {
                ElMessage({
                  type: 'success',
                  message: '编辑成功',
                  showClose: true
                })
              }
              getTableData()
              closeDialog()
            }
            break
          default:
            // eslint-disable-next-line no-lone-blocks
            {
              ElMessage({
                type: 'error',
                message: '未知操作',
                showClose: true
              })
            }
            break
        }
      }
    })
  }
  
  
  </script>
  
  <style scoped lang="scss">
  .button-box {
    padding: 10px 20px;
    .el-button {
      float: right;
    }
  }
  .warning {
    color: #dc143c;
  }
  </style>
  